/***************************************************************************
 *   Copyright (C) 2005 by Alexander Saal                                  *
 *   alex.saal@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*
  lokale datei includieren die wir unbedingt brauchen
  sonst funktioniert berhaubt nichts :) msste klar sein
*/
#include "vsprojectgen.h"

/*Qt3 dateien includieren, die wir bentigen*/
#include <qapplication.h>
#include <qfiledialog.h>
#include <qradiobutton.h>
#include <qlineedit.h>
#include <qprocess.h>
#include <qstringlist.h>
#include <qmessagebox.h>
#include <qlabel.h>
#include <qfile.h>

VsProjectGen::VsProjectGen( QWidget* parent,  const char* name, WFlags fl )
		: frmProjectGenerator( parent, name, fl )
{}

VsProjectGen::~VsProjectGen()
{}

void VsProjectGen::slotCreate_VcDspProFile()
{
     /*ein neuen QProcess erzeugen*/
     procCreateVs = new QProcess( this );
     
     /*der QStringList die parameter bergeben die wir brauchen um die datei zu erzeugen*/
     proFileVs.append( "qmake" );
     proFileVs.append( "-spec" );                         
     proFileVs.append( "win32-msvc" );
     proFileVs.append( "-t" );
     proFileVs.append( "vcapp" );
     proFileVs.append( "-o" );
     proFileVs.append( lineEditVs_ProFile->text() );
     proFileVs.append( lineEditQt_ProFile->text() );
     
     /*dem QProcess den Inhalt der QStringList bergeben*/
     procCreateVs->setArguments( proFileVs );
     
     /*den QProcess starteb*/
     procCreateVs->start();          
     
     /*dem QProcess eine SIGNAL und ein SLOT zuweisen, siehe dazu etwas weiter unten*/
     connect( procCreateVs, SIGNAL( processExited() ), this, SLOT( slotReadStdoutVs() ) );
     
     /*die QStringList wieder leeren, sonst knnten probleme auftauchen*/
     proFileVs.clear();
}

void VsProjectGen::slotCreate_VcProjProFile()
{
     procCreateVsNet = new QProcess( this );
     proFileVsNet.append( "qmake" );
     proFileVsNet.append( "-spec" );
     proFileVsNet.append( "win32-msvc.net" );
     proFileVsNet.append( "-t" );
     proFileVsNet.append( "vcapp" );
     proFileVsNet.append( "-o" );
     proFileVsNet.append( lineEditVs_ProFile->text() );
     proFileVsNet.append( lineEditQt_ProFile->text() );
         
     procCreateVsNet->setArguments( proFileVsNet );
     procCreateVsNet->start();
     connect( procCreateVsNet, SIGNAL( processExited() ), this, SLOT( slotReadStdoutVsNet() ) );
     proFileVsNet.clear();
}

void VsProjectGen::slotOpen_QtProFile()
{
     /*ein QFileDialog erzeugen*/
     QFileDialog* fd = new QFileDialog( this, "Select Qt Projectfile", TRUE );
     
     /*einen neuen QString erzeugen*/
     QString fileName;
     
     /*
       wir setzen den Modus auf ExistingFile, es gibt auch andere modis
       das heist soviel wie: ist die angegebene Datei vorhanden, dan zeig sie
     */
     fd->setMode( QFileDialog::ExistingFile );
     
     /*
       nun setzen wir einen Filter, fr eine bestimmte datei
       in dem fall die vom qtdesigner generierte projekt datei
       man kann auch mehr benutzen, aber hier reicht ein filter
     */
     fd->setFilter( "Qt Projectfile (*.pro)" );
     
     /*
       jetzt setzen wir ein Pfad, das heisst in dem fall, den pfad
       wo sich gerade die ausfhrbare datei befindet
     */
     fd->setDir( QDir::currentDirPath() );
     
     /*zeige fersteckte dateien an, mit false kann man es auschalten*/
     fd->setShowHiddenFiles(true);
     
     /*jetzt zeige unsern QFileDialog*/
     fd->show();
     
     /*
       wenn der QFileDialog geffent ist und man ok drckt, wird die ausgewhlte
       datei in das textfeld gesetzt, und dazu brauchten wir wie oben, den QString filename;
     */
     if ( fd->exec() == QDialog::Accepted )
             fileName = fd->selectedFile();
     lineEditQt_ProFile->setText(fileName);
}

void VsProjectGen::slotSave_VsProFile()
{
     /*
       berprfen ob der QRadioButton aktiviert ist
       wenn nicht ist der andere aktiviert
       sonst kommt wie unten eine Nachricht QMessageBox
     */
    if( rbtnVs_File->isChecked() ){
        
        /*eine QFileDialog aufrufen der dateien speichert*/
        QString fddsp = QFileDialog::getSaveFileName(
               QDir::currentDirPath(),
               "Visual Studio 6 Projectfile (*.dsp) ",
               this,
               "save file dialog",
               "Save Vs Projectfile" );
               
        /*und dem textlabel die ausgewhlte datei bergeben*/
        lineEditVs_ProFile->setText(fddsp + ".dsp");
    }else if( rbtnVs_NetFile->isChecked() ){          
        QString fdvcproj = QFileDialog::getSaveFileName(
               QDir::currentDirPath(),
               "Visual Studio .Net Projectfile (*.vcproj) ",
               this,
               "save file dialog",
                "Save Vs Projectfile" );
        lineEditVs_ProFile->setText(fdvcproj + ".vcproj");
    }else{
        QMessageBox::information( this, "Projektfilegenerator", "Please select a Projectfile." );
    }
}

void VsProjectGen::slotQuit()
{
     /*
       Anwendung beenden, man kann auch im QtDesigner
       den slot auf close() setzen, aber wir gehen auf
       nummer sicher, es gibt flle wo sich die Anwenung
       nicht richtig beendet
     */
     qApp->quit();
}

void VsProjectGen::slotReadStdoutVs()
{
     /*ein neues QFile setzen mit dem inhalt der lineEdit*/
     QFile fdsp( lineEditVs_ProFile->text() );   
     
     /*
       nun berprfen wir, ob die Datei vorhanden ist, ist sie
       vorhanden bringe die erfolgsmeldung sonst die fehlermeldung
     */  
     if ( fdsp.exists() ){
         textLabel_Info->setText( "File [ " + lineEditVs_ProFile->text() + " ] created" );
     }else{
         textLabel_Info->setText( "File [ " + lineEditVs_ProFile->text() + " ] not created" );
     }

     
}

void VsProjectGen::slotReadStdoutVsNet()
{
     QFile fvcproj( lineEditVs_ProFile->text() );
     
     if ( fvcproj.exists() ){
         textLabel_Info->setText( "File [ " + lineEditVs_ProFile->text() + " ] created");
     }else{
         textLabel_Info->setText( "File [ " + lineEditVs_ProFile->text() + " ] not created" );
     } 
}
