/***************************************************************************
 *   Copyright (C) 2005 by Alexander Saal                                  *
 *   alex.saal@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef VSPROJECTGEN_H
#define VSPROJECTGEN_H

#include "tmp/ui/frmprojectgenerator.h"

class QProcess;
class QStringList;

class VsProjectGen : public frmProjectGenerator
{
    Q_OBJECT

public:
    VsProjectGen( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~VsProjectGen();
    
     QProcess *procCreateVs;           /*Process fr Visual Studio*/
     QProcess *procCreateVsNet;        /*Process fr Visual Studio .Net*/
     
     QStringList proFileVs;            /*StringList fr Visual Studio*/
     QStringList proFileVsNet;         /*StringListVisual Studio .Net*/

public slots:
    void slotCreate_VcProjProFile();   /*Erstellt eine *.vcproj datei fr Visual Studio .Net*/
    void slotCreate_VcDspProFile();    /*Erstellt eine *.dsp datei fr Visual Studio und/oder Dev C++*/
    
    void slotOpen_QtProFile();         /*ffnen der vom QtDesigner erzeugten projekt datei *.pro*/
    void slotSave_VsProFile();         /*Speichert die angegeben datei dsp oder vcproj*/
    
    void slotQuit();                   /*Schliesst die Anwendung*/
    
    void slotReadStdoutVs();           /*Ausgabe fr Visual Studio (ob erfolgreich erstellt)*/
    void slotReadStdoutVsNet();        /*Ausgabe fr Visual Studio .Net (ob erfolgreich erstellt)*/
};

#endif // VSPROJECTGEN_H
